//+------------------------------------------------------------------+
//|                                                 Grucha Index.mq4 |
//|                                                   gaa1@poczta.fm |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Grzegorz Antosiewicz"
#property link      "gaa1@poczta.fm "

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue


//---- buffers
double ExtMapBuffer1[];
double tab[];
double srednia[];
double dResult, gora,dol, suma,close,open,wynik;


extern string TimeFrame  = "Current time frame";
extern int Okresy= 10 ;
extern int MA_Okresy= 10 ;
int timeFrame;
string indicatorFileName;
bool   returnBars;

int init()
  {
  IndicatorBuffers(3);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(0,"Grucha % Index");
   SetIndexLabel(1,"Ma of Grucha % Index");
   SetIndexBuffer(1,srednia);
   SetIndexBuffer(2,tab);
   SetIndexDrawBegin(0, Okresy);
   
   timeFrame = stringToTimeFrame(TimeFrame);
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame == "returnBars");
   
   
//----
   return(1);
  }

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Okresy,MA_Okresy,0,y);
                  srednia[i]       = iCustom(NULL,timeFrame,indicatorFileName,"",Okresy,MA_Okresy,1,y);
            }
            return(0);
         }
 
 
//---- gwna ptla
   int pos = limit;
   while(pos>=0)
{
      close= Close[pos];
      open = Open[pos];
           
      dResult = open - close ;                          //wartos swiecy do zmiennej
      tab[pos]= dResult; //przypisuje wartosc do tablicy

     
      if(Bars-pos > (Okresy-1) )             //sprawdzam czy istnieje n elemntowa tablica
  {
      gora = 0;
      dol  = 0;
      for(int l = pos + (Okresy-1); l>=pos; l--)      //odliczam n okresow
     {
      if(tab[l]<0)
      {
      gora += tab[l];
      }                    //sumuje wartosci ze wzrostowych slupkow  do gora
      else if(tab[l]>=0)
      {
      dol -= tab[l]
      ;
      }         
       
     }
      if(dol<=0)
      {dol = dol*(-1);}
      if(gora<=0)
      {gora = gora*(-1);}
      suma = dol + gora ; // sumuje wartosci wszytkich slupkow
           
      if(suma == 0)
      {wynik = 0;
      //Print("Suma = 0");
      }     
  }
                   

       
        if(suma >0)
      {
         wynik =
         ( (gora / suma) *100
         );
      }
         else
        {
        wynik = 0 ;
        }
         
                        
         ExtMapBuffer1[pos]= wynik ;
         pos--;
     
    //Comment(dol,"dol",gora,"gora" );
     }

   int   index=Bars-MA_Okresy;
   
    while(index>=0)
 {    
    srednia[index]=iMAOnArray(ExtMapBuffer1,0,MA_Okresy,0,0,index);
     
   //Comment(tab2[index],"srednia->",srednia[index]);  
   index--;
   
 }
   
   return(0);
  }
//+------------------------------------------------------------------+ 

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}